;=============================================================================
;  	 OLED- SSD1306   I2C.
;	: 12864 . 8   21  68 (+2).
;  	:	   
;	:	 2018 
;-----------------------------------------------------------------------------
;  : R0, R16, R17, R18, R19, ZL, ZH
;=============================================================================
;         
;	(0xD5)	   :
;		(0x80) -    
;		(0F0) -  -   1
;	(0xA8)	   (1...64):
;		(0x3F) -    : 1/64)
;	(0xD3)	  : 
;		(0x00) -  
;	(0x40)	   : (0x40 -   )
;	(0x8D)	  DC/DC :
;		(0x10) -  - (V  )
;		(0x14) -  - DC/DC 
; 	(0xA0)      ( X) - ( )
;	(0xA1)	    ( X) - ( )
;	(0x0)	   -   (   )
;	(0xC8)	   -   (   )
;	(0xDA)	  COM:
;		(0x12) - 0x02 - 0x12
;	(0x81)	  :
;		(001...0xFF) -     (1...256)
;	(0xD9)	  DC/DC :
; 		(0xF1) -   DC/DC 
;		(0x22) - V  
;	(0xDB)	  VcomH (   ):
;		(0x20) - 0x20 -> 0.77xVcc (0x00-0x10-0x20-0x30-0x40-0x50-0x60-0x70)
;	(0xA4)	   RAM.
;	 (0xA5)	    RAM.
;	(0xA6)	   
;    (0xA7)     
;	(0x20)	   :
;		(0x00) -        ()
; 		(001) -       
; 		(010) -  ()   
;
;	(0xAF)	 .
;	(0xAE)	  ( ).
;
;	(0xB0...0xB7)   ()    
;	(0x00...0x0F)  .    RAM
;	(0x10...0x1F)  .    RAM
;
;   0x78 ( 0x7A)  
;   0x79 ( 0x7)  
;        (0x00).
;        (0x40).
;=============================================================================
	.def fnt_d = R15			; : 0 - , 1 - 
;      SREG -    .
;           .
	;
	.DSEG						;   SRAM ()
	str_num: 	.byte 1			;   Y
	poz_num:	.byte 1  		;    X
	.CSEG

;=============================================================================
;		    LCD
;------------------------------------------------------------------------------
lcd_init_tab: 
		.db 0xD5, 0x80, 0xA8, 0x3F, 0xD3, 0x00, 0x40, 0x8D
		.db 0x14, 0xA1, 0xC8, 0xDA, 0x12, 0x81, 0xCF, 0xD9
		.db 0xF1, 0xDB, 0x20, 0xA4, 0xA6, 0x20, 0x10, 0x22
		.db 0x00, 0x07, 0x21, 0x00, 0x7F, 0xAF
		
;==============================================================================
 lcd_init:				; LCD 
		ldi R17,0xAE					;(0xAE)	  ( )
		rcall lcd_com					;   LCD
		DELAY 1							; 32  (10 )
		
		ldi ZL,low(lcd_init_tab*2) 		;   
		ldi ZH,high(lcd_init_tab*2) 	;
		ldi R17,30 						;-  = 30
		
i_lcd:	rcall IIC_Start					;  
		ldi temp,0x78					; I2C-  (0x78)
		rcall iic_send					;   LCD
		ldi temp,0x00					;000 -   
		rcall iic_send					;    LCD
	  	rcall Delay10us					; 10 
		lpm 							;  
		mov temp,R0						;
		rcall iic_send					;   LCD
		rcall IIC_Stop 					;  
		
		rcall Delay10us					; 10 
		adiw ZL,1 						;  
		dec R17 						;    , -
		brne i_lcd 						;    
		
		rcall lcd_clr					; 
		ret
		
;=============================================================================
; 			 /  
;-----------------------------------------------------------------------------
 lcd_clr:
		ldi R19,0           			;  
clr_pg:	mov R16,R19						;
		rcall lcd_Y						;  LCD  
		;
		rcall clr_line					;  
		inc R19							; 
		cpi R19,8						;    ,-
		brne clr_pg						;  e 
		
		ret
;=============================================================================
; 			 /    
;-----------------------------------------------------------------------------
clr_line:
		clr R16							;
		rcall lcd_X						;   
		
		ldi R18,128           			;   
		rcall IIC_Start					;  
		ldi temp,0x78					; I2C-  (0x78)
		rcall iic_send					;   LCD
		ldi temp,0x40					;0x40 -   
		rcall iic_send					;    LCD
		
clr_c:	ldi temp,0x00					;    
		rcall iic_send					;    LCD
		rcall Delay10us					; 10 
		dec R18							;    , -
		brne clr_c						;   
		rcall IIC_Stop 					;  
		rcall Delay10us					; 10 
		
		ret
		
;=============================================================================
;	     LCD
;	temp1 (R17) -   
;------------------------------------------------------------------------------
  lcd_com: 		 						;
 		rcall IIC_Start					;  
		ldi temp,0x78					; I2C-  (0x78)
		rcall iic_send					;   LCD
		ldi temp,0						;  
		rcall iic_send					;    LCD
 		mov temp,R17					;  
 		rcall iic_send					;   
 		rcall IIC_Stop 					;  
 		
 		ret
 		
;=============================================================================
;		     LCD
; 	[R16 = char] -  (ASCII)  
;=============================================================================
lcd_put_char:
		; .     
		cpi R16,168						;    , -
		brne  fnt_3						;
		subi R16,(40)					;   
		rjmp fnt_1						;
fnt_3:	cpi R16,184						;    , -
		brne  fnt_2						;
		subi R16,(55)					;   
		rjmp fnt_1						;
		
fnt_2:	cpi R16,150						;    147,-
		brmi fnt_1						;    
		subi R16,160					;
		ldi ZL,low(Rus*2-32*6) 			; .  
		ldi ZH,high(Rus*2-32*6) 		;    
		rjmp ch_adr					;
		
fnt_1:	ldi ZL,low(font_tab*2-32*6) 	; .  
		ldi ZH,high(font_tab*2-32*6) 	;   
		
ch_adr: clr R17							;
		;    ,   6
		lsl R16 						;    2
		rol R17 						;
		add ZL,R16 						;  . 
		adc ZH,R17 						;
		lsl R16 						;    4
		rol R17 						;
		add ZL,R16 						;  . 
		adc ZH,R17 						;
		;   LCD
		ldi R17,6 						;   
		rcall IIC_Start					;  
		ldi temp,0x78					; I2C-  (0x78)
		rcall iic_send					;   LCD
		ldi temp,0x40					;  (0x40)
		rcall iic_send					;   LCD
		rcall Delay10us					; 10 
		
 chr_nxt:		;    LCD
		lpm 							;   
		mov temp,R0						;
		
		brtc PC+2						;   
		com temp						;  
		rcall iic_send					;   LCD
		; 
		sbrs fnt_d,0					;    ,-
		rjmp put_n						;     
		mov temp,R0						;
		brtc PC+2						;   
		com temp						;  
		rcall iic_send					;     LCD
 put_n:	rcall Delay10us					; 10 
		
		adiw Z,1						;    
		dec R17							;    , -
		brne chr_nxt					;   ,  -
		rcall IIC_Stop 					;   
		ret
		
;=============================================================================
;		     LCD
;  :   R16 =   X -   0...21
;----------------------------------------------------------------------------
lcd_X: 	sts poz_num,R16			;     
		ldi R18,8          	;    
		mul R16,R18           	;   
 		mov R17,R0				;   R0
 		clr R1					;
 mem_X:		; .     LCDCommand(0x00|(x&0x0f))
		andi R17,0x0F			;  
		rcall lcd_com			;   LCD
		; .     LCDCommand(0x10|(x>>4))
		mov R17,R0				;
		lsr R17					;
		lsr R17					;
		lsr R17					;
		lsr R17					;
		ori R17,0x10			;
		rcall lcd_com			;   LCD
		
		ret
;----------------------------------------------------------------------------
;	    LCDCommand(0xB0|(y&0x07))
;  :   R16 = Y	 (Y -   0...7

lcd_Y:  ori R16,0xB0			;  
		sts str_num,R16			;     
		mov R17,R16				;
		rcall lcd_com			;   LCD
		
		ret

;==============================================================================
;		    
;         0.
; Z -   ;
;------------------------------------------------------------------------------
 Str_LCD:
		push ZL					;   
		push ZH					;  
		lpm 					;  
		tst R0					;    0,  -
		breq w_str				;  
		mov R16,R0				;
		
		rcall lcd_put_char		;   LCD
		rcall Delay10us			; 10 
		
		pop ZH					;  
		pop ZL					;  
		adiw Z,1				;   .
		rjmp Str_LCD			;  
		
w_str:	pop ZH					;  
		pop ZL					;  
		
 		ret
		
;=============================================================================
; 	     10 
; 		c   RCALL  RET
;-----------------------------------------------------------------------------
	Delay10us:
			PUSH R19
		;	LDI	R19, 23
			LDI	R19, 12
			DEC	R19
			BRNE PC-1
			POP	R19
			RET
			
;============================================================================
;         4  2432
;  R16 -    
;  R3  -   
;  R17 -    
;  R19 -    
;=============================================================================
Fnt_Digit_24:	;
		push  ZL              		 ;
		push  ZH              		 ;
		push  R17              		 ;
		push  R19              		 ;
		
		ldi ZL,low(Digit_24*2) 			; . 
		ldi ZH,high(Digit_24*2) 		;   
		
		mov R19,R16          		;    
		cpi R19,0x0B           		;    ,-
		brne PC+3           		;    
		clr R16           			; , -
		rjmp dig_st           		;    
		
		tst R16							;   0, 
		breq dig_st						;   
nxt_dg:	adiw Z,48						;   
		adiw Z,48						;
		dec R16							;   , -
		brne nxt_dg						;  . 
		
dig_st:	ldi R17,4						;-  
		mov R3,R17						;   
str_trp:ldi R17,24 						;    
		rcall IIC_Start					;  
		ldi temp,0x78					; I2C-  (0x78)
		rcall iic_send					;   LCD
		ldi temp,0x40					;  (0x40)
		rcall iic_send					;   LCD
		rcall Delay10us					; 10 
		
trp_nxt:
		cpi R19,0x0B           			;    ,-
		brne PC+3           			;    
		clr R16           				; , -
		rjmp PC+2
		
		lpm temp,Z+        		  		;    
		rcall iic_send					;   LCD
		rcall Delay10us					; 10 
		dec R17							;    , -
		brne trp_nxt					;   
		rcall IIC_Stop 					;   
		;
		dec R3							;    , -
		breq end_trp					;   ,  -
		lds R16,str_num					;    
		inc R16							;
		rcall lcd_Y						;  . 
		lds R16,poz_num					;    
		rcall lcd_X						;    
		
		rjmp str_trp					;   . 
		
		;   
end_trp:lds R16,str_num					;    
		subi R16,3						;     3
		rcall lcd_Y						;    
		lds R16,poz_num					;    
		subi R16,-3						; 38=24
		rcall lcd_X						;    
		
		pop   R19              	 	;
		pop   R17              	 	;
		pop   ZH              	 	;
		pop   ZL              	 	;
 		ret
		
;=================================================================================================
	.include "Font_SSD1306_4row.asm" 		;  
;=================================================================================================
	
	